<template>
  <div class="mr-5 text-center">
    <v-autocomplete dense rounded outlined filled :items="sortedItems" v-model="selectedItem" return-object :search-input.sync="searchString" cache-items item-label="Label" item-text="Label" hide-details>
      <template v-slot:item="data">
        <template>
          <v-list-item-avatar>
            <v-icon v-if="data.item.Type === 'USER'">mdi-account</v-icon>
            <v-icon v-if="data.item.Type === 'RECIPE'">mdi-silverware</v-icon>
          </v-list-item-avatar>
          <v-list-item-content v-text="data.item.Label"></v-list-item-content>
        </template>
      </template>
      <template v-slot:append>
        <v-btn icon small dark @click="searchItem" :disabled="!selectedItem">
          <v-icon>mdi-magnify</v-icon>
        </v-btn>
      </template>
    </v-autocomplete>
  </div>
</template>
<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Watch } from "vue-property-decorator";
import SearchItem, {
  usersToSearchItems,
  recipesToSearchItems,
} from "../../../transport/SearchItem";
import UserService from "../../../services/UserService";
import RecipeService from "../../../services/RecipeService";
@Component({
  components: {
    GlobalSearchBar,
  },
})
export default class GlobalSearchBar extends Vue {
  searchString: string = "";
  userService: UserService = null;
  recipeService: RecipeService = null;
  searchItems: SearchItem[] = [];
  selectedItem: SearchItem = null;

  @Watch("searchString", { deep: true })
  onInputSelect(val) {
    this.fetchItems();
  }
  get sortedItems() {
    return this.searchItems.sort((a, b) => (a.Label > b.Label ? 1 : -1));
  }
  mounted() {
    this.userService = new UserService();
    this.recipeService = new RecipeService();
    this.fetchItems();
  }

  searchItem() {
    console.log(this.selectedItem);

    if (this.selectedItem.Type === "USER")
      this.$router
        .push({
          name: "user-profile",
          params: { userId: this.selectedItem.Id.toString() },
        })
        .catch(err => {});
    if (this.selectedItem.Type === "RECIPE")
      this.$router
        .push({
          name: "recipe",
          params: { id: this.selectedItem.Id.toString() },
        })
        .catch(err => {});
    this.selectedItem = null;
    this.searchString = "";
    this.searchItems = [];
  }

  fetchItems() {
    this.searchItems = [];
    this.userService.searchUsers(this.searchString).then(users => {
      this.searchItems.push(...usersToSearchItems(users));
    });
    this.recipeService
      .searchRecipes(this.searchString)
      .then(recipes => this.searchItems.push(...recipesToSearchItems(recipes)));
  }
}
</script>
